using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using GroupLab.Networking;
using System.Collections;
using System.Net.Mail;


namespace AI2
{
    public partial class Form1 : Form
    {
        User currentUser;
        public Form1()
        {
            InitializeComponent();
            SetupSharedDictionary();
            SetupUI();
            Login();
            UpdateBuddyList();
        }

        private void SetupUI()
        {
            this.listView1.View = View.Details;
            this.listView1.Columns.Add("Group", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Status", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Role", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Guid", -2, HorizontalAlignment.Left);

            listView2.View = View.Details;
            listView2.Columns.Add("User", -2, HorizontalAlignment.Left);
            listView2.Columns.Add("Status", -2, HorizontalAlignment.Left);

            listView3.View = View.Details;
            listView3.Columns.Add("User", -2, HorizontalAlignment.Left);
            listView3.Columns.Add("Status", -2, HorizontalAlignment.Left);
        }

        private void SetupSharedDictionary()
        {
            string url = GlobalVariables.SDUrl;
            if (DialogResult.OK == GroupLab.Networking.UrlPrompt.Show(ref url))
            {
                // add your code here
                // it might look something like this

                this.sharedDictionary1.Url = url;
                GlobalVariables.SDUrl = url;
                this.sharedDictionary1.Opened += new EventHandler(SD_Opened);
                this.sharedDictionary1.Closed += new EventHandler(SD_Closed);
                this.sharedDictionary1.Open();
            }
            else
            {
                this.Close();
            }
        }

        private void SD_Opened(object sender, System.EventArgs args)
        {
            this.subscription1.BeginInit();
            this.subscription1.Dictionary = this.sharedDictionary1;
            this.subscription1.Pattern = "/users/&";
            //this.subscription1.Notified += new SubscriptionEventHandler(this.S1_Notified);
            this.subscription1.EndInit();
            this.subscription2.BeginInit();
            this.subscription2.Dictionary = this.sharedDictionary1;
            this.subscription2.Pattern = "/users/&/profile";
            this.subscription2.Notified += new SubscriptionEventHandler(this.S2_Notified);
            this.subscription2.EndInit();
        }

        private void SD_Closed(object sender, System.EventArgs args)
        {

        }

        private void S2_Notified(object sender, SubscriptionEventArgs args)
        {
            User profile = (User)args.Value;
            if (profile == null)
            {
                profile = (User)args.PreviousValue;
            }
            if (args.Reason == SubscriptionNotification.Add)
            {
                ListViewItem item = new ListViewItem(profile.email);
                item.SubItems.Add(""+profile.status);
                listView3.Items.Add(item);
            }
            else
            {
                foreach (ListViewItem item in listView3.Items)
                {
                    if (item.Text == profile.email)
                    {
                        if (args.Reason == SubscriptionNotification.Remove)
                        {
                            listView3.Items.Remove(item);
                            MessageBox.Show("Kicked Out");
                            currentUser = null;
                            this.Close();
                        }
                        else
                        {
                            //item.SubItems.Clear();
                            User oldProfile = args.PreviousValue as User;
                            if (currentUser != null && profile.email == oldProfile.email && profile.status == oldProfile.status)
                            {
                                //MessageBox.Show("Logged On Elsewhere");
                                //currentUser = null;
                                //this.Close();
                            }
                            item.SubItems[1].Text = ""+profile.status;
                        }
                    }
                }
            }

            if (currentUser != null)
            {
                UpdateBuddyList();
            }
            //JoinBuddy(profile.email);
            /*listView3.Items.Clear();
            listView3.BeginUpdate();

            foreach (SharedDictionary.Entry i in
                (this.sharedDictionary1["/users/&"] as IEnumerable))
            {

                ListViewItem item = new ListViewItem(i.Value);
                //item.SubItems.Add("" + user.status);
                //item.SubItems.Add("" + user.role);

                listView3.Items.Add(item);

            }
            listView1.EndUpdate();*/
        }

        private bool Authenticate(string email, string password)
        {
            foreach (SharedDictionary.Entry i in
                (this.sharedDictionary1["/users/&"] as IEnumerable))
            {
                if ((string)i.Value == email)
                {
                    if (!this.sharedDictionary1.Contains(i.Path + "/password"))
                    {
                        this.sharedDictionary1[i.Path + "/password"] = password;
                        currentUser = this.sharedDictionary1[i.Path + "/profile"] as User;
                        currentUser.account = AccountStatus.Joined;
                        currentUser.password = password;
                        currentUser.status = UserStatus.Online;
                        this.sharedDictionary1[i.Path + "/profile"] = currentUser;
                        MessageBox.Show("Activated");
                        return true;
                    }
                    else if ((string)this.sharedDictionary1[i.Path + "/password"] == password)
                    {
                        currentUser = (User)this.sharedDictionary1[i.Path + "/profile"];
                        //currentUser = new User();
                        //currentUser.guid = (string)this.sharedDictionary1[i.Path + "/guid"];
                        //currentUser.email = email;
                        //currentUser.password = password;
                        //this.sharedDictionary1[i.Path + "/status"] = UserStatus.Online;
                        //if (currentUser.status == UserStatus.Online)
                        //{
                            //MessageBox.Show("Already Logged In");
                            //return false;
                        //}
                        //else
                        //{
                            currentUser.status = UserStatus.Online;
                            this.sharedDictionary1[i.Path + "/profile"] = currentUser;
                            //currentUser.role = (UserRole)this.sharedDictionary1[i.Path + "/role"];
                            MessageBox.Show("Logged In");
                            this.Text = currentUser.email;
                            return true;
                        //}
                    }
                    else
                    {
                        MessageBox.Show("Not Logged In");
                        return false;
                    }
                }
            }
            currentUser = SignUp(email, password);
            MessageBox.Show("Signed Up");
            return true;
        }

        private void Login()
        {
            Form2 loginDlg = new Form2();
            if (loginDlg.ShowDialog() == DialogResult.OK)
            {
                if (Authenticate(loginDlg.Email, loginDlg.Password) != true)
                {
                    this.Close();
                }
                else
                {
                    this.subscription4.BeginInit();
                    this.subscription4.Dictionary = this.sharedDictionary1;
                    this.subscription4.Pattern = "/groups/&";
                    //this.subscription4.Notified += new SubscriptionEventHandler(this.S3_Notified);
                    this.subscription4.EndInit();
                    this.subscription3.BeginInit();
                    this.subscription3.Dictionary = this.sharedDictionary1;
                    this.subscription3.Pattern = "/users/" + currentUser.guid + "/groups/&/status";
                    this.subscription3.Notified += new SubscriptionEventHandler(this.S3_Notified);
                    this.subscription3.EndInit();
                    this.subscription5.BeginInit();
                    this.subscription5.Dictionary = this.sharedDictionary1;
                    this.subscription5.Pattern = "/users/" + currentUser.guid + "/buddies";
                    this.subscription5.Notified += new SubscriptionEventHandler(this.S5_Notified);
                    this.subscription5.EndInit();
                }
            }
            else
            {
                this.Close();
            }
        }

        private void S3_Notified(object sender, SubscriptionEventArgs args)
        {
            UserGroupStatus ugStatus = (UserGroupStatus)args.Value;
            if (ugStatus == null)
            {
                ugStatus = (UserGroupStatus)args.PreviousValue;
            }
            if (args.Reason == SubscriptionNotification.Add)
            {
                //MessageBox.Show(ugStatus.groupGuid);
                //MessageBox.Show((string)this.sharedDictionary1["/groups/" + ugStatus.groupGuid]);
                ListViewItem item = new ListViewItem((string)this.sharedDictionary1["/groups/" + ugStatus.groupGuid]);
                item.SubItems.Add(""+ugStatus.membership);
                item.SubItems.Add("" + ugStatus.role);
                item.SubItems.Add("" + ugStatus.groupGuid);
                this.listView1.Items.Add(item);
                if (ugStatus.role != MemberType.Owner && ugStatus.membership == Membership.Invited)
                {
                    MessageBox.Show("Invited");
                }
            }
            else
            {
                foreach (ListViewItem item in this.listView1.Items)
                {
                    if (item.SubItems[3].Text == ugStatus.groupGuid)
                    {
                        if (args.Reason == SubscriptionNotification.Remove)
                        {
                            this.listView1.Items.Remove(item);
                            MessageBox.Show("Removed");
                            //currentUser = null;
                            //this.Close();
                        }
                        else
                        {
                            //item.SubItems.Clear();
                            item.SubItems[1].Text ="" + ugStatus.membership;
                            item.SubItems[2].Text = "" + ugStatus.role;
                            item.SubItems[3].Text = "" + ugStatus.groupGuid;
                        }
                    }
                }
            }

        }

        private User SignUp(string email, string password)
        {
            User user = new User();
            user.guid = System.Guid.NewGuid().ToString();
            user.email = email;
            user.password = password;
            user.status = UserStatus.Online;
            user.account = AccountStatus.Joined;
            

            this.sharedDictionary1["/users/" + user.guid] = user.email;
            this.sharedDictionary1["/users/" + user.guid + "/password"] = user.password;
            //this.sharedDictionary1["/users/" + user.guid + "/guid"] = user.guid;
            //this.sharedDictionary1["/users/" + user.guid + "/status"] = user.status;
            this.sharedDictionary1["/users/" + user.guid +"/profile"] = user;

            return user;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            LogOut();
            sharedDictionary1.Close();
        }

        private void LogOut()
        {
            if (currentUser != null)
            {
                currentUser.status = UserStatus.Offline;
                this.sharedDictionary1["/users/" + currentUser.guid + "/profile"] = currentUser;
                currentUser = null;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string groupName = CreateGroup();
            if (groupName == null)
            {
                return;
            }
            Group group = new Group();
            group.guid = System.Guid.NewGuid().ToString();
            group.name = groupName;
            GroupUserStatus guStatus = new GroupUserStatus();
            guStatus.accountStatus = AccountStatus.Joined;
            guStatus.membership = Membership.Joined;
            guStatus.role = MemberType.Owner;
            guStatus.groupGuid = group.guid;
            guStatus.userGuid = currentUser.guid;
            guStatus.email = currentUser.email;
            UserGroupStatus ugStatus = new UserGroupStatus();
            ugStatus.membership = Membership.Joined;
            ugStatus.role = MemberType.Owner;
            ugStatus.groupGuid = group.guid;
            ugStatus.userGuid = currentUser.guid;

            this.sharedDictionary1["/groups/" + group.guid] = group.name;
            //this.sharedDictionary1["/groups/" + group.guid+"/url"] = "http://www.google.ca";
            this.sharedDictionary1["/groups/" + group.guid + "/users/" + currentUser.guid + "/status"] = guStatus;
            //this.sharedDictionary1["/groups/" + group.guid + "/users/" + currentUser.guid + "/role"] = UserRole.Owner;

            this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + group.guid + "/status"] = ugStatus;

            //ListViewItem item = new ListViewItem(group.name);
            //item.SubItems.Add("" + ugStatus.membership);
            //item.SubItems.Add("" + ugStatus.role);
            //listView1.Items.Add(item);

            //Form3 form3 = new Form3(group.guid);
            //form3.Show();

        }

        private string CreateGroup()
        {
            Form4 loginDlg = new Form4();
            if (loginDlg.ShowDialog() == DialogResult.OK)
            {
                return loginDlg.GroupName;
            }
            else
            {
                return null;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a group");
                return;
            }
            //MessageBox.Show(listView1.SelectedItems[0].SubItems[0].Text);
            JoinGroup(listView1.SelectedItems[0].SubItems[3].Text);
            Form3 form3 = new Form3(listView1.SelectedItems[0].SubItems[3].Text, currentUser);
            form3.Text = listView1.SelectedItems[0].Text;
            form3.Show();
        }

        private void JoinGroup(string guid)
        {
            GroupUserStatus guStatus = this.sharedDictionary1["/groups/" + guid + "/users/" + currentUser.guid + "/status"] as GroupUserStatus;
            if (guStatus.membership == Membership.Joined)
            {
                return;
            }
            guStatus.membership = Membership.Joined;
            this.sharedDictionary1["/groups/" + guid + "/users/" + currentUser.guid + "/status"] = guStatus;
            UserGroupStatus ugStatus = this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + guid + "/status"] as UserGroupStatus;
            ugStatus.membership = Membership.Joined;
            this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + guid + "/status"] = ugStatus;
        }

        private void AddGroup(string guid)
        {
            if (!this.sharedDictionary1.Contains("/groups/" + guid + "/users/" + currentUser.guid + "/status"))
            {
                MessageBox.Show("Not Added");
                return;
            }
            GroupUserStatus guStatus = this.sharedDictionary1["/groups/" + guid + "/users/" + currentUser.guid + "/status"] as GroupUserStatus;
            if (guStatus.membership < Membership.Invited)
            {
                guStatus.membership = Membership.Invited;
                this.sharedDictionary1["/groups/" + guid + "/users/" + guStatus.userGuid + "/status"] = guStatus;

                UserGroupStatus ugStatus = new UserGroupStatus();
                ugStatus.groupGuid = guid;
                ugStatus.userGuid = currentUser.guid;
                ugStatus.membership = Membership.Invited;
                ugStatus.role = MemberType.Viewer;
                this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + guid + "/status"] = ugStatus;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            AddBuddy(textBox1.Text);
            textBox1.Clear();
        }

        private void AddBuddy(string email)
        {
            if (this.sharedDictionary1.Contains("/users/" + currentUser.guid + "/buddies"))
            {
                SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
                foreach (Buddy buddy1 in buddies)
                {
                    if (email == buddy1.email)
                    {
                        MessageBox.Show("Already Added");
                        return;
                    }
                }
            }
            Buddy buddy = new Buddy();
            buddy.email = email;
            User user = GetUser(buddy.email);
            if (user != null)
            {
                buddy.guid = user.guid;
                buddy.type = AccountStatus.Joined;
            }
            else
            {
                buddy.guid = "0";
                buddy.type = AccountStatus.Added;
            }
            this.sharedDictionary1["/users/" + currentUser.guid + "/buddies#-0"] = buddy;
            
        }

        private void RemoveBuddy()
        {
            SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
            sharedDictionary1.SuspendNotifications();
            sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = null;
            foreach (Buddy buddy in buddies)
            {
                if (listView2.SelectedItems[0].Text != buddy.email)
                {
                    sharedDictionary1["/users/" + currentUser.guid + "/buddies#-0"] = buddy;
                }
            }
            sharedDictionary1.ResumeNotifications();
        }

        private void S5_Notified(object sender, SubscriptionEventArgs args)
        {
            listView2.Items.Clear();

            listView2.BeginUpdate();
            //MessageBox.Show("/users/" + currentUser.guid + "/buddies");
            SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
            //SharedDictionary.Vector buddies = args.Value as SharedDictionary.Vector;
            //sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = null;

            if (buddies != null)
            {
                foreach (Buddy buddy in buddies)
                {
                    ListViewItem item = new ListViewItem(buddy.email);
                    item.SubItems.Add("" + buddy.type);

                    listView2.Items.Add(item);
                }
            }
  
            listView2.EndUpdate();
        }

        private User GetUser(string email)
        {
            foreach (SharedDictionary.Entry i in
                (this.sharedDictionary1["/users/&"] as IEnumerable))
            {
                if ((string)i.Value == email)
                {
                    return (User)this.sharedDictionary1[i.Path+"/profile"];
                }
            }
            return null;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (listView2.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a user");
                return;
            }
            RemoveBuddy();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (listView2.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a buddy");
                return;
            }
            InviteBuddy(listView2.SelectedItems[0].Text);
        }

        private void InviteBuddy(string email)
        {
            SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
            foreach (Buddy buddy in buddies)
            {
                if (email == buddy.email)
                {
                    SendInvitation(email);
                    if (buddy.type == AccountStatus.Added)
                    {
                        buddy.type = AccountStatus.Invited;
                    }
                    //sharedDictionary1["/users/" + currentUser.guid + "/buddies#-0"] = buddy;
                    break;
                }
            }
            sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = buddies;
        }

        /*private void JoinBuddy(string email)
        {
            SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
            foreach (Buddy buddy in buddies)
            {
                if (email == buddy.email)
                {
                    SendInvitation(email);
                    if (buddy.type != AccountStatus.Joined)
                    {
                        buddy.type = AccountStatus.Joined;
                    }
                    //sharedDictionary1["/users/" + currentUser.guid + "/buddies#-0"] = buddy;
                    break;
                }
            }
            sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = buddies;
        }*/

        private void UpdateBuddyList()
        {
            if (!this.sharedDictionary1.Contains("/users/" + currentUser.guid + "/buddies"))
            {
                return;
            }
            SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;

            if (buddies != null)
            {
                foreach (Buddy buddy in buddies)
                {
                    User user = GetUser(buddy.email);
                    //ListViewItem item = new ListViewItem(buddy.email);
                    if (user != null && buddy.type != user.account)
                    {
                        buddy.type = user.account;
                    }
                }
            }

            sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = buddies;
        }

        private void SendInvitation(string email)
        {
            MailMessage msg = new MailMessage();
            msg.To.Add(email);

            msg.Subject = "you are invited";
            msg.From = new MailAddress(currentUser.email);
            msg.Body = "please download at "+GlobalVariables.DLUrl;
            SmtpClient smtp = new SmtpClient("smtp.ucalgary.ca");
            smtp.Credentials = new System.Net.NetworkCredential("yibsun", "abCD123");
            smtp.Send(msg);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a group");
                return;
            }
            UserGroupStatus ugStatus = this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + listView1.SelectedItems[0].SubItems[3].Text + "/status"] as UserGroupStatus;
            if (ugStatus.role != MemberType.Owner)
            {
                QuitGroup(listView1.SelectedItems[0].SubItems[3].Text);
            }
            else
            {
                RemoveGroup(listView1.SelectedItems[0].SubItems[3].Text);
            }
        }

        private void RemoveGroup(string guid)
        {
            /*UserGroupStatus ugStatus = this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + guid + "/status"] as UserGroupStatus;
            if (ugStatus.role != MemberType.Owner)
            {
                MessageBox.Show("only the owner can remove a group");
                return;
            }*/
            ArrayList memberList = new ArrayList();
            foreach (SharedDictionary.Entry i in
                (this.sharedDictionary1["/groups/"+guid+"/users/&/status"] as IEnumerable))
            {
                GroupUserStatus guStatus = i.Value as GroupUserStatus;
                if(this.sharedDictionary1.Contains("/users/" + guStatus.userGuid + "/groups/" + guid + "/status")) 
                {
                    memberList.Add("/users/" + guStatus.userGuid + "/groups/" + guid + "/status");
                    //this.sharedDictionary1.Remove("/users/" + guStatus.userGuid + "/groups/" + guid + "/status");
                }
            }
            foreach (string member in memberList)
            {
                this.sharedDictionary1.Remove(member);
            }
            this.sharedDictionary1.Remove("/groups/" + guid + "*");
        }

        private void QuitGroup(string guid)
        {
            /*UserGroupStatus ugStatus = this.sharedDictionary1["/users/" + currentUser.guid + "/groups/" + guid + "/status"] as UserGroupStatus;
            if (ugStatus.role != MemberType.Owner)
            {
                MessageBox.Show("the owner can not quit a group");
                return;
            }*/
            this.sharedDictionary1.Remove("/groups/" + guid + "/users/" + currentUser.guid + "*");
            this.sharedDictionary1.Remove("/users/" + currentUser.guid + "/groups/" + guid + "*");
        }

        private void listView2_DragDrop(object sender, DragEventArgs e)
        {
            AddBuddy((string)e.Data.GetData(typeof(string)));
        }

        private void listView2_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void listView2_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void listView1_DragDrop(object sender, DragEventArgs e)
        {
            AddGroup((string)e.Data.GetData(typeof(string)));
        }

        private void listView1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void listView1_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void listView2_ItemDrag(object sender, ItemDragEventArgs e)
        {
            if (listView2.SelectedIndices.Count > 0)
            {
                this.DoDragDrop(listView2.SelectedItems[0].Text, DragDropEffects.Copy);
            }
        }


    }
}