using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using GroupLab.Networking;
using System.Net.Mail;

namespace AI2
{
    public partial class Form3 : Form
    {
        //Collabrary.Photo webPage;
        String url;
        String guid;
        Group group;
        User currentUser;
        bool isOwner;
        ArrayList containers;
        public Form3(string guid, User user)
        {
            InitializeComponent();
            //webPage = new Collabrary.PhotoClass();
            //zoom();
            this.group = new Group();
            group.guid = guid;
            this.guid = guid;
            this.currentUser = user;
            this.sharedDictionary1.Url = GlobalVariables.SDUrl;
            this.sharedDictionary1.Open();
            //userList = new ArrayList();
            populateUserList();
            containers = new ArrayList();
            PopulateComboBox();
            //this.Text = group.name;
            //AddTabs();
        }

        private void PopulateComboBox()
        {
            comboBox1.Items.Add("Web Item");
            comboBox1.Items.Add("Photo Item");
        }

        private void MainForm_Resize(object sender, EventArgs e)
        {
            //zoom();
            ResizeAllContainers();
        }

        private void ResizeAllContainers()
        {
            foreach (UserControl container in containers)
            {
                //container.Size.Height = ClientSize.Height;
                //container.Size.Width = ClientSize.Width;
                container.Size = new Size(tabControl1.SelectedTab.Size.Width, tabControl1.SelectedTab.Size.Height);
                //container.ClientSize = 
            }
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {

        }

        private void subscription1_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
        {
            if (e.Reason == SubscriptionNotification.Add)
            {

                Container container = e.Value as Container;
                if (container.type == ContainerType.Web)
                {
                    TabPage newPage = new TabPage();
                    WebItem webItem = new WebItem(this.group, isOwner, container.guid);
                    containers.Add(webItem);
                    ResizeAllContainers();
                    newPage.Text = "Web";
                    tabControl1.TabPages.Insert(tabControl1.TabCount - 1, newPage);
                    newPage.Controls.Add(webItem);
                    newPage.Tag = container;
                }
                else
                {
                    TabPage newPage = new TabPage();
                    PictureItem webItem = new PictureItem(this.group, isOwner, container.guid);
                    containers.Add(webItem);
                    ResizeAllContainers();
                    newPage.Text = "Picture";
                    tabControl1.TabPages.Insert(tabControl1.TabCount - 1, newPage);
                    newPage.Controls.Add(webItem);
                    newPage.Tag = container;
                }
                //this.url = (string)e.Value;
                //updateAll();
            }
            else if (e.Reason == SubscriptionNotification.Remove)
            {
                Container rmContainer = e.PreviousValue as Container;
                TabPage selectedTab = null;
                foreach (TabPage tab in tabControl1.TabPages)
                {
                    Container container = tab.Tag as Container;
                    if (container != null && container.guid == rmContainer.guid)
                    {
                        selectedTab = tab;
                        break;
                    }
                }
                if (selectedTab != null)
                {
                    tabControl1.TabPages.Remove(selectedTab);
                }
            }
        }

        private void sharedDictionary1_Opened(object sender, EventArgs e)
        {
            this.subscription3.BeginInit();
            this.subscription3.Pattern = "/users/&";
            //this.subscription2.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription2_Notified);
            this.subscription3.EndInit();

            this.subscription4.BeginInit();
            this.subscription4.Pattern = "/users/&/profile";
            this.subscription4.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription4_Notified);
            this.subscription4.EndInit();

            this.subscription1.BeginInit();
            this.subscription1.Pattern = "/groups/" + group.guid + "/containers/&";
            this.subscription1.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription1_Notified);
            this.subscription1.EndInit();

            this.subscription6.BeginInit();
            this.subscription6.Pattern = "/groups/" + group.guid + "/image";
            //this.subscription6.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription6_Notified);
            this.subscription6.EndInit();

            this.subscription2.BeginInit();
            this.subscription2.Pattern = "/groups/"+group.guid+"/users/&/status";
            this.subscription2.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription2_Notified);
            this.subscription2.EndInit();

            this.subscription5.BeginInit();
            this.subscription5.Pattern = "/users/" + currentUser.guid + "/buddies";
            //this.subscription5.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription2_Notified);
            this.subscription5.EndInit();
            Login();
            SetupUI();
            //updateAll();

        }

        private void Login()
        {
            if (this.sharedDictionary1.Contains("/groups/" + group.guid + "/users/" + currentUser.guid + "/status"))
            {
                GroupUserStatus guStatus = this.sharedDictionary1["/groups/" + group.guid + "/users/" + currentUser.guid + "/status"] as GroupUserStatus;
                if (guStatus.role == MemberType.Owner)
                {
                    isOwner = true;
                }
                else
                {
                    isOwner = false;
                }
            }
            else
            {
                MessageBox.Show("Not Entered");
                this.Close();
            }
        }

        private void SetupUI()
        {
            if (isOwner)
            {
                listView1.AllowDrop = true;
                //tabPage1.AllowDrop = true;
            }
            else
            {
                textBox1.Visible = false;
                button1.Visible = false;
                button2.Visible = false;
                button3.Visible = false;
                tabControl1.TabPages.Remove(tabPage1);
            }
        }

        private void subscription2_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
        {
            GroupUserStatus status = (GroupUserStatus)e.Value;
            if (status == null)
            {
                status = (GroupUserStatus)e.PreviousValue;
                if (status.email == currentUser.email)
                {
                    MessageBox.Show("Removed");
                    this.Close();
                }
            }
            //User user = this.sharedDictionary1["/users/"+status.userGuid+"/profile"] as User;
            if (e.Reason == SubscriptionNotification.Add)
            {
                ListViewItem item = new ListViewItem(status.email);
                item.SubItems.Add("" + status.membership);
                item.SubItems.Add("" + status.role);
                if (status.membership == Membership.Joined)
                {
                    User user = this.sharedDictionary1["/users/" + status.userGuid + "/profile"] as User;
                    item.SubItems.Add("" + user.status);
                }
                else
                {
                    item.SubItems.Add("" + status.accountStatus);
                }
                item.SubItems.Add(""+status.userGuid);
                this.listView1.Items.Add(item);
                
            }
            else
            {
                foreach (ListViewItem item in this.listView1.Items)
                {
                    if (item.Text == status.email)
                    {
                        if (e.Reason == SubscriptionNotification.Remove)
                        {
                            listView1.Items.Remove(item);
                            //MessageBox.Show("Removed");
                            //currentUser = null;
                            //this.Close();
                        }
                        else
                        {
                            item.SubItems[1].Text="" + status.membership;
                            item.SubItems[2].Text="" + status.role;
                            if (status.membership == Membership.Joined)
                            {
                                User user = this.sharedDictionary1["/users/" + status.userGuid + "/profile"] as User;
                                item.SubItems[3].Text = "" + user.status;
                            }
                            else
                            {
                                item.SubItems[3].Text = "" + status.accountStatus;
                            }
                            item.SubItems[4].Text = "" + status.userGuid;
                        }
                    }
                }
            }
            /*listView1.Items.Clear();

            listView1.BeginUpdate();
            SharedDictionary.Vector userVector = sharedDictionary1[GlobalVariables.GUID + "users"] as SharedDictionary.Vector;
            int index = -1;
            int i = 0;
            foreach (User user in userVector)
            {
                ListViewItem item = new ListViewItem(user.email);
                item.SubItems.Add("" + user.status);
                item.SubItems.Add("" + user.role);

                listView1.Items.Add(item);
                if (user.email == GlobalVariables.currentUser.email)
                {
                    index = i;
                }
                i++;
            }
            if (index == -1)
            {
                sharedDictionary1.Close();
                MessageBox.Show("you are removed");
                Environment.Exit(0);
            }
            listView1.EndUpdate();*/
        }

        private void subscription4_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
        {
            User user = e.Value as User;
            if (user == null)
            {
                user = e.PreviousValue as User;
            }
            foreach (ListViewItem item in this.listView1.Items)
            {
                if (item.Text == user.email)
                {
                    GroupUserStatus guStatus = this.sharedDictionary1["/groups/" + group.guid + "/users/" + item.SubItems[4].Text + "/status"] as GroupUserStatus;
                    if (e.Reason == SubscriptionNotification.Add && user.password != null)
                    {

                        guStatus.accountStatus = AccountStatus.Joined;
                        guStatus.userGuid = user.guid;
                        this.sharedDictionary1.Remove("/groups/" + group.guid + "/users/" + item.SubItems[4].Text + "/status");
                        item.SubItems[4].Text = guStatus.userGuid;
                        this.sharedDictionary1["/groups/" + group.guid + "/users/" + guStatus.userGuid + "/status"] = guStatus;
                    }
                    else if (e.Reason == SubscriptionNotification.Remove)
                    {

                    }
                    else
                    {
                        if (guStatus.membership == Membership.Joined)
                        {
                            //MessageBox.Show("hello "+user.status);
                            item.SubItems[3].Text = "" + user.status;
                        }
                    }
                }
            }
        }

        private void populateUserList()
        {
            this.listView1.Columns.Add("User", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Membership", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Role", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Status", -2, HorizontalAlignment.Left);
            this.listView1.Columns.Add("Guid", 0, HorizontalAlignment.Left);
            /*

            User user = new User();
            user.email = "yibsun";
            user.status = UserStatus.Added;
            user.role = UserRole.Owner;

            ListViewItem item = new ListViewItem(user.email);
            item.SubItems.Add("" + user.status);
            item.SubItems.Add("" + user.role);

            listView1.Items.Add(item);*/
            /*
            if (GlobalVariables.currentUser.role == UserRole.Owner)
            {
                listView1.AllowDrop = true;
                tabPage1.AllowDrop = true;
            }
            else
            {
                listView1.AllowDrop = false;
                tabPage1.AllowDrop = false;
                textBox1.Visible = false;
                button1.Visible = false;
                button2.Visible = false;
                button3.Visible = false;
                listView1.Dock = DockStyle.Fill;
            }*/

        }

        private void listView1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void listView1_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void listView1_DragDrop(object sender, DragEventArgs e)
        {
            AddMember((string)e.Data.GetData(typeof(string)));
            /*User user = new User();
            user.email = (string)e.Data.GetData(typeof(string));
            user.status = UserStatus.Added;
            user.role = UserRole.Viewer;

            sharedDictionary1[GlobalVariables.GUID + "users#-0"] = user;*/
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            //sharedDictionary1.Close();
            /*SharedDictionary.Vector userVector = sharedDictionary1[GlobalVariables.GUID + "users"] as SharedDictionary.Vector;
            int i = 0;
            foreach (User user in userVector)
            {
                if (GlobalVariables.currentUser.email == user.email)
                {
                    user.status = UserStatus.Offline;
                    sharedDictionary1[GlobalVariables.GUID + "users#+" + i] = user;
                    break;
                }
                i++;
            }*/
        }

        /*private void sendInvitations()
        {
            MailMessage msg = new MailMessage();
            SharedDictionary.Vector userVector = sharedDictionary1[GlobalVariables.GUID + "users"] as SharedDictionary.Vector;
            int i = 0;
            foreach (User user in userVector)
            {
                if (user.status < UserStatus.Offline)
                {
                    msg.To.Add(user.email);
                }
                i++;
            }

            msg.Subject = "awareness icon invitation";
            msg.From = new MailAddress(GlobalVariables.currentUser.email);
            msg.Body = "hello";
            SmtpClient smtp = new SmtpClient(GlobalVariables.SMTPURL);
            smtp.Credentials = new System.Net.NetworkCredential("yibsun", "abCD123");
            smtp.Send(msg);
        }*/

        private void button1_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a user");
                return;
            }

            InviteMember(listView1.SelectedItems[0].SubItems[4].Text);
            InviteBuddy(listView1.SelectedItems[0].SubItems[4].Text);
            /*sendInvitations();
            MessageBox.Show("invitation sent");*/
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (HasMember(textBox1.Text))
            {
                MessageBox.Show("Member Already Added");
                return;
            }
            AddMember(textBox1.Text);
            AddBuddy(textBox1.Text);
            textBox1.Clear();
            
            /*User user = new User();
            user.email = textBox1.Text;
            user.status = UserStatus.Added;
            user.role = UserRole.Viewer;

            sharedDictionary1[GlobalVariables.GUID + "users#-0"] = user;*/
        }

        private void AddMember(string email)
        {
            User user = GetUser(email);
            GroupUserStatus guStatus = new GroupUserStatus();
            guStatus.groupGuid = this.group.guid;
            guStatus.role = MemberType.Viewer;
            if (user == null)
            {
                guStatus.accountStatus = AccountStatus.Added;
                guStatus.membership = Membership.Added;
                guStatus.userGuid = System.Guid.NewGuid().ToString();
            }
            else
            {
                //guStatus.accountStatus = AccountStatus.Joined;
                guStatus.accountStatus = user.account;
                guStatus.membership = Membership.Added;
                guStatus.userGuid = user.guid;
            }


            guStatus.email = email;
            this.sharedDictionary1["/groups/" + group.guid + "/users/" + guStatus.userGuid + "/status"] = guStatus;
        }

        private bool HasMember(string email)
        {
            foreach (SharedDictionary.Entry i in (this.sharedDictionary1["/groups/" + group.guid + "/users/&/status"] as IEnumerable))
            {
                GroupUserStatus guStatus = i.Value as GroupUserStatus;
                if (guStatus.email == email)
                {
                    return true;
                }
            }
            return false;
        }

        private void InviteMember(string userGuid)
        {


            GroupUserStatus guStatus = this.sharedDictionary1["/groups/" + group.guid + "/users/" + userGuid + "/status"] as GroupUserStatus;
            User user;
            if (!this.sharedDictionary1.Contains("/users/"+userGuid + "/profile"))
            {
                user = GetUser(guStatus.email);
                if (user == null)
                {
                    user = new User();
                    user.guid = guStatus.userGuid;
                    user.email = guStatus.email;
                    user.password = null;
                    user.status = UserStatus.Offline;
                    user.account = AccountStatus.Invited;


                    this.sharedDictionary1["/users/" + user.guid] = user.email;
                    //this.sharedDictionary1["/users/" + user.guid + "/password"] = user.password;
                    //this.sharedDictionary1["/users/" + user.guid + "/guid"] = user.guid;
                    //this.sharedDictionary1["/users/" + user.guid + "/status"] = user.status;
                    this.sharedDictionary1["/users/" + user.guid + "/profile"] = user;

                    //send email
                }
                else
                {
                    //guStatus = new GroupUserStatus();
                    //guStatus.groupGuid = this.group.guid;
                    //guStatus.role = MemberType.Viewer;
                    guStatus.accountStatus = AccountStatus.Joined;
                    //guStatus.membership = Membership.Added;
                    guStatus.userGuid = user.guid;
                    this.sharedDictionary1.Remove("/groups/" + group.guid + "/users/" + userGuid + "/status");
                }
            }
            else
            {
                user = this.sharedDictionary1["/users/" + userGuid + "/profile"] as User;
                //pop up dialog
            }
            SendInvitation(guStatus.email);
            if (guStatus.membership < Membership.Invited)
            {
                guStatus.membership = Membership.Invited;
                if (guStatus.accountStatus < AccountStatus.Invited)
                {
                    guStatus.accountStatus = AccountStatus.Invited;
                }
                this.sharedDictionary1["/groups/" + group.guid + "/users/" + guStatus.userGuid + "/status"] = guStatus;

                UserGroupStatus ugStatus = new UserGroupStatus();
                ugStatus.groupGuid = this.group.guid;
                ugStatus.userGuid = user.guid;
                ugStatus.membership = Membership.Invited;
                ugStatus.role = MemberType.Viewer;
                this.sharedDictionary1["/users/" + user.guid + "/groups/" + this.group.guid + "/status"] = ugStatus;
            }

        }

        private void SendInvitation(string email)
        {
            MailMessage msg = new MailMessage();
            msg.To.Add(email);

            msg.Subject = "you are invited to join web item";
            msg.From = new MailAddress(currentUser.email);
            msg.Body = "please download at " + GlobalVariables.DLUrl;
            SmtpClient smtp = new SmtpClient("smtp.ucalgary.ca");
            smtp.Credentials = new System.Net.NetworkCredential("yibsun", "abCD123");
            smtp.Send(msg);
        }

        private User GetUser(string email)
        {
            foreach (SharedDictionary.Entry i in
                (this.sharedDictionary1["/users/&"] as IEnumerable))
            {
                if ((string)i.Value == email)
                {
                    return (User)this.sharedDictionary1[i.Path + "/profile"];
                }
            }
            return null;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (listView1.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a user");
                return;
            }
            if (listView1.SelectedItems[0].Text == currentUser.email)
            {
                MessageBox.Show("Cannot remove yourself, the owner");
                return;
            }
            RemoveMember(listView1.SelectedItems[0].SubItems[4].Text);
            /*if (listView1.SelectedIndices.Count < 1)
            {
                MessageBox.Show("please select a user");
                return;
            }

            SharedDictionary.Vector userVector = sharedDictionary1[GlobalVariables.GUID + "users"] as SharedDictionary.Vector;
            sharedDictionary1.SuspendNotifications();
            sharedDictionary1[GlobalVariables.GUID + "users"] = null;
            int i = 0;
            foreach (User user in userVector)
            {
                if (!listView1.SelectedIndices.Contains(i))
                {
                    sharedDictionary1[GlobalVariables.GUID + "users#-0"] = user;
                }
                i++;
            }
            sharedDictionary1.ResumeNotifications();*/
        }

        private void RemoveMember(string userGuid)
        {

            //UserGroupStatus ugStatus = this.sharedDictionary1["/users/" + userGuid + "/groups/" + this.group.guid + "/status"] as UserGroupStatus;
            if (sharedDictionary1.Contains("/users/" + userGuid + "/groups/" + this.group.guid + "/status"))
            {
                this.sharedDictionary1.Remove("/users/" + userGuid + "/groups/" + this.group.guid + "/status");
            }
            this.sharedDictionary1.Remove("/groups/" + group.guid + "/users/" + userGuid + "/status");

        }

        private void tabPage1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Clicks > 1 || !isOwner)
            {
                return;
            }
            this.DoDragDrop(GlobalVariables.IMMSG+this.group.guid, DragDropEffects.Copy);
        }

        private void InviteBuddy(string email)
        {
            SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
            foreach (Buddy buddy in buddies)
            {
                if (email == buddy.email)
                {
                    SendInvitation(email);
                    if (buddy.type == AccountStatus.Added)
                    {
                        buddy.type = AccountStatus.Invited;
                    }
                    //sharedDictionary1["/users/" + currentUser.guid + "/buddies#-0"] = buddy;
                    break;
                }
            }
            sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = buddies;
        }

        private void AddBuddy(string email)
        {
            if (this.sharedDictionary1.Contains("/users/" + currentUser.guid + "/buddies"))
            {
                SharedDictionary.Vector buddies = sharedDictionary1["/users/" + currentUser.guid + "/buddies"] as SharedDictionary.Vector;
                foreach (Buddy buddy1 in buddies)
                {
                    if (email == buddy1.email)
                    {
                        return;
                    }
                }
            }
            //sharedDictionary1["/users/" + currentUser.guid + "/buddies"] = buddies;
            Buddy buddy = new Buddy();
            buddy.email = email;
            User user = GetUser(buddy.email);
            if (user != null)
            {
                buddy.guid = user.guid;
                buddy.type = AccountStatus.Joined;
            }
            else
            {
                buddy.guid = "0";
                buddy.type = AccountStatus.Added;
            }
            this.sharedDictionary1["/users/" + currentUser.guid + "/buddies#-0"] = buddy;

        }

        private void tabControl1_DoubleClick(object sender, EventArgs e)
        {
            if (!isOwner)
            {
                return;
            }
            if (tabControl1.SelectedTab.Tag != null)
            {
                Container container = tabControl1.SelectedTab.Tag as Container;
                IEnumerator enumerator = tabControl1.SelectedTab.Controls.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    //MessageBox.Show("hello");
                    UserControl control = enumerator.Current as UserControl;
                    if (control != null)
                    {
                        containers.Remove(control);
                        control.Dispose();
                    }
                }
                tabControl1.TabPages.RemoveAt(tabControl1.SelectedIndex);
                this.sharedDictionary1.Remove("/groups/" + group.guid + "/containers/" + container.guid);

            }
            /*if (tabControl1.SelectedIndex > 0 && tabControl1.SelectedIndex < tabControl1.TabCount - 1)
            {
                tabControl1.TabPages.RemoveAt(tabControl1.SelectedIndex);
            }*/
        }

        private void comboBox1_SelectionChangeCommitted(object sender, EventArgs e)
        {
            if (comboBox1.SelectedIndex == 0)
            {
                AddContainer(tabControl1.SelectedIndex);
            }
            else
            {
                AddPict(tabControl1.SelectedIndex);
            }
            
            
        }

        private void AddContainer(Container container)
        {

        }

        private void AddContainer(int index)
        {
            WebContainer webContainer = new WebContainer();
            webContainer.guid = System.Guid.NewGuid().ToString();
            webContainer.type = ContainerType.Web;
            webContainer.url = "http://www.google.ca";
            this.sharedDictionary1["/groups/" + group.guid + "/containers/"+webContainer.guid] = webContainer;
            /*
            TabPage newPage = new TabPage();
            WebItem webItem = new WebItem(this.group, isOwner,webContainer.guid);
            containers.Add(webItem);
            ResizeAllContainers();
            newPage.Text = "Web";
            tabControl1.TabPages.Insert(index, newPage);
            newPage.Controls.Add(webItem);*/
        }

        private void AddPict(int index)
        {
            PictureContainer picContainer = new PictureContainer();
            picContainer.guid = System.Guid.NewGuid().ToString();
            picContainer.type = ContainerType.Picture;
            picContainer.picture = null;
            this.sharedDictionary1["/groups/" + group.guid + "/containers/" + picContainer.guid] = picContainer;
            /*
            TabPage newPage = new TabPage();
            PictureItem webItem = new PictureItem(this.group, isOwner,picContainer.guid);
            containers.Add(webItem);
            ResizeAllContainers();
            newPage.Text = "Picture";
            tabControl1.TabPages.Insert(index, newPage);
            newPage.Controls.Add(webItem);*/
        }

        private void AddTabs()
        {
            if (this.sharedDictionary1.Contains("/groups/" + group.guid + "/url"))
            {
                AddContainer(1);
            }
            if (this.sharedDictionary1.Contains("/groups/" + group.guid + "/image"))
            {
                AddPict(1);
            }
        }
    }
}