using System;
using System.Collections.Generic;
using System.Text;

namespace AI2
{
    interface IContainer
    {
        string GetGUID();
    }

    public enum ContainerType
    {
        Web,
        Picture
    }

    [Serializable]
    public class Container
    {
        public string guid;
        public ContainerType type;
    }

    [Serializable]
    public class WebContainer : Container
    {
        public string url;
    }

    [Serializable]
    public class PictureContainer : Container
    {
        public byte[] picture;
    }
}
