using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;

namespace AI2
{
    public partial class PictureItem : UserControl
    {
        //Collabrary.Photo pict;
        Bitmap picture;
        Group group;
        bool isOwner;
        String guid;
        public PictureItem()
        {
            InitializeComponent();
        }

        public PictureItem(Group group, bool isOwner, string guid)
        {
            InitializeComponent();
            this.group = group;
            this.isOwner = isOwner;
            this.guid = guid;
            this.sharedDictionary1.Url = GlobalVariables.SDUrl;
            this.sharedDictionary1.Open();
            SetupUI();
            //SetImage();
        }

        private void SetupUI()
        {
            if (isOwner)
            {
                this.AllowDrop = true;
            }
            else
            {
                this.AllowDrop = false;
            }
        }

        private void sharedDictionary1_Opened(object sender, EventArgs e)
        {
            this.subscription1.BeginInit();
            this.subscription1.Pattern = "/groups/" + group.guid + "/containers/" + this.guid;
            this.subscription1.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription1_Notified);
            this.subscription1.EndInit();
        }

        private void subscription1_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
        {
            PictureContainer container = e.Value as PictureContainer;
            //picture = (Bitmap) e.Value;
            //Image img = e.Value as Image;
            //PhotoObj pic = (PhotoObj)e.Value;
            //picture = this.sharedDictionary1["/groups/" + group.guid + "/image"] as Bitmap;
            //picture = pic.photo;
            //byte[] byteArrayIn = (byte[]) e.Value;
            if (container == null || container.picture == null)
            {
                return;
            }
            MemoryStream ms = new MemoryStream(container.picture);
            Image returnImage = Image.FromStream(ms);
            picture = returnImage as Bitmap;
            //Collabrary.JPEG jpg = new Collabrary.JPEGClass();
            //this.pict = (Collabrary.Photo)jpg.Decompress((Collabrary.Memory)e.Value);
            //LoadPictureBox();
            pictureBox1.Image = ResizeImage((float)picture.Height/(float)picture.Width);
        }

        /*private void SetImage()
        {
            Collabrary.Photo picture = new Collabrary.PhotoClass();
            picture.Grab("http://www.wikipedia.org");
            Collabrary.JPEG jpg = new Collabrary.JPEGClass();
            jpg.Quality = 80;
            this.sharedDictionary1["/groups/" + group.guid + "/image"] = jpg.Compress(picture);
        }

        private void LoadPictureBox()
        {
            Collabrary.Photo p = pict.Copy(0, 0, 0, 0, Collabrary.PhotoCopyStyle.Pixels) as Collabrary.Photo;
            p.Resize(pictureBox1.Width, pictureBox1.Height, true);
            Image img = Bitmap.FromHbitmap(p.Hbitmap);
            System.Runtime.InteropServices.Marshal.ReleaseComObject(p);
            this.pictureBox1.Image = img;
            //this.pictureBox1.Load("http://www.google.ca");
        }*/

        private Bitmap ResizeImage(float ratio)
        {
            Bitmap img = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics g = Graphics.FromImage((Image)img);
            //MessageBox.Show(""+ratio);
            if (pictureBox1.Width * ratio > pictureBox1.Height)
            {
                g.DrawImage(this.picture, (float)((pictureBox1.Width - pictureBox1.Height / ratio) / 2), 0, (float)(pictureBox1.Height / ratio), pictureBox1.Height);
            }
            else
            {
                g.DrawImage(this.picture, 0, (float)((pictureBox1.Height - pictureBox1.Width * ratio) / 2), pictureBox1.Width, (float)(pictureBox1.Width * ratio));
            }
            //g.DrawImage(this.picture, 0, 0, pictureBox1.Width, pictureBox1.Height);
            g.Dispose();
            //MessageBox.Show(img.Width + "X" + img.Height);
            return img;
        }

        private void PictureItem_DragDrop(object sender, DragEventArgs e)
        {
            string[] filepath = (string[])e.Data.GetData(DataFormats.FileDrop);
            Bitmap img = new Bitmap(@filepath[0]);
            //picture = (Bitmap)Image.FromFile(@filepath[0]);
            //picture = new Bitmap(@filepath[0]);
            //this.sharedDictionary1.SuspendNotifications();
            //PhotoObj pic = new PhotoObj();
            //pic.photo = img;
            MemoryStream ms = new MemoryStream();
            img.Save(ms, ImageFormat.Bmp);
            byte[] bitmapData = ms.ToArray();
            PictureContainer container = this.sharedDictionary1["/groups/" + group.guid + "/containers/" + this.guid] as PictureContainer;
            container.picture = bitmapData;
            this.sharedDictionary1["/groups/" + group.guid + "/containers/" + this.guid] = container;
            //this.sharedDictionary1.ResumeNotifications();
            img.Dispose();
            //MessageBox.Show(filepath[0]);
            //picture = img;
            //pictureBox1.Image = Image.FromFile(filepath[0]);
            //MessageBox.Show(picture.Width + "X" + picture.Height);
            //pictureBox1.Image = ResizeImage(picture.Height / picture.Width);

            //pictureBox1.Image = picture;
        }

        private void PictureItem_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            } 
        }

        private void PictureItem_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            } 
        }

        private void PictureItem_Resize(object sender, EventArgs e)
        {
            if (picture != null)
            {
                pictureBox1.Image = ResizeImage((float)picture.Height / (float)picture.Width);
            }
        }

        private void pictureBox1_Resize(object sender, EventArgs e)
        {

        }
    }
}
