using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using GroupLab.Networking;

namespace AI2
{
    public partial class WebItem : UserControl
    {
        //Collabrary.Photo webPage;
        Bitmap thumbnail;
        Group group;
        bool isOwner;
        String url;
        String guid;
        public WebItem()
        {
            InitializeComponent();
        }

        public WebItem(Group group, bool isOwner, string guid)
        {
            InitializeComponent();
            Zoom();
            this.group = group;
            this.isOwner = isOwner;
            this.guid = guid;
            this.sharedDictionary1.Url = GlobalVariables.SDUrl;
            this.sharedDictionary1.Open();
            SetupUI();
        }

        private void SetupUI()
        {
            if (isOwner)
            {
                this.AllowDrop = true;
            }
            else
            {
                this.AllowDrop = false;
            }
        }

        private void subscription1_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
        {
            WebContainer container = e.Value as WebContainer;
            if (container == null)
            {
                return;
            }
            this.url = container.url;
            updateAll();
        }

        private void sharedDictionary1_Opened(object sender, EventArgs e)
        {
            this.subscription1.BeginInit();
            this.subscription1.Pattern = "/groups/" + group.guid + "/containers/"+this.guid;
            this.subscription1.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription1_Notified);
            this.subscription1.EndInit();
            updateAll();
        }

        private void Zoom()
        {
            if (this.ClientSize.Height <= 100)
            {
                this.panel1.Visible = false;
                this.panel2.Visible = false;
                this.panel3.Visible = true;
            }
            else if (this.ClientSize.Height <= 500)
            {
                if (this.thumbnail != null)
                {
                    //ResizePictureBox();
                    pictureBox1.Image = ResizeImage();
                }
                this.panel1.Visible = false;
                this.panel2.Visible = true;
                this.panel3.Visible = false;
            }
            else
            {
                this.panel1.Visible = true;
                this.panel2.Visible = false;
                this.panel3.Visible = false;
            }
        }

        /*private void UpdatePictureBox()
        {
            webPage = new Collabrary.PhotoClass();
            webPage.Grab(this.url);
            ResizePictureBox();
        }

        private void ResizePictureBox()
        {
            Collabrary.Photo p = webPage.Copy(0, 0, 0, 0, Collabrary.PhotoCopyStyle.Pixels) as Collabrary.Photo;
            p.Resize(pictureBox1.Width, pictureBox1.Height, true);
            Image img = Bitmap.FromHbitmap(p.Hbitmap);
            System.Runtime.InteropServices.Marshal.ReleaseComObject(p);
            this.pictureBox1.Image = img;
            //this.pictureBox1.Load("http://www.google.ca");
        }*/

        private void UpdateWebBrowser()
        {
            if (this.url != null && this.url.StartsWith("http://"))
            {
                this.webBrowser1.Navigate(this.url);
            }
        }

        private void UpdateURLLabel()
        {
            this.linkLabel1.Text = this.url;
        }

        private void WebItem_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                string test = (string)e.Data.GetData(typeof(string));
                if (test.StartsWith("http://"))
                {
                    e.Effect = DragDropEffects.Copy;
                }
                else
                {
                    e.Effect = DragDropEffects.None;
                }
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void WebItem_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(string)))
            {
                string test = (string)e.Data.GetData(typeof(string));
                if (test.StartsWith("http://"))
                {
                    e.Effect = DragDropEffects.Copy;
                }
                else
                {
                    e.Effect = DragDropEffects.None;
                }
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }          
        }

        private void WebItem_DragDrop(object sender, DragEventArgs e)
        {
            //this.url = (string)e.Data.GetData(typeof(string));
            WebContainer container = this.sharedDictionary1["/groups/" + group.guid + "/containers/" + this.guid] as WebContainer;
            container.url = (string)e.Data.GetData(typeof(string));
            //this.sharedDictionary1["/groups/" + group.guid + "/url"] = url;
            this.sharedDictionary1["/groups/" + group.guid + "/containers/" + this.guid] = container;
            updateAll();
        }

        private void updateAll()
        {
            UpdateURLLabel();
            //UpdatePictureBox();
            UpdatePict();
            UpdateWebBrowser();
        }

        private void UpdatePict()
        {
            webBrowser2.Navigate(this.url);
        }

        private void tabPage_MouseDown(object sender, MouseEventArgs e)
        {
            this.DoDragDrop(GlobalVariables.IMMSG + this.group.guid, DragDropEffects.Copy);
        }

        private void WebItem_Resize(object sender, EventArgs e)
        {
            Zoom();
        }

        private void webBrowser2_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            Bitmap docImage = new Bitmap(1024,768);
            webBrowser2.DrawToBitmap(docImage, new Rectangle(0,
                    0, webBrowser2.Width, webBrowser2.Height));
            thumbnail = docImage;
            pictureBox1.Image = ResizeImage();
        }

        private Bitmap ResizeImage()
        {
            Bitmap img = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics g = Graphics.FromImage((Image)img);
            if (pictureBox1.Width * 0.75 > pictureBox1.Height)
            {
                g.DrawImage(thumbnail, (float)((pictureBox1.Width - pictureBox1.Height / 0.75)/2), 0, (float)(pictureBox1.Height / 0.75), pictureBox1.Height);
            }
            else
            {
                g.DrawImage(thumbnail, 0, (float)((pictureBox1.Height - pictureBox1.Width * 0.75) / 2), pictureBox1.Width, (float)(pictureBox1.Width * 0.75));
            }
            g.Dispose();
            return img;
        }
    }
}
